from .download import download_zip, download_file
from pathlib import Path
down_path = Path(__file__).parent
xz_url = "addons_file"+"/"+down_path.name+"/"
download_zip(xz_url + "icons.zip",down_path)


if "bpy" in locals():
    import importlib
    importlib.reload(GoB)
    importlib.reload(preferences)
    importlib.reload(addon_updater)
else:
    from . import GoB
    from . import preferences
    from . import addon_updater

import bpy
import os
import bpy.utils.previews
from .translation.translate import GetTranslationDict


bl_info = {
    "name": "GoB",
    "description": "An unofficial GOZ-like addon for Blender",
    "author": "ODe, JoseConseco, Daniel Grauer",
    "version": (4, 0, 4),
    "blender": (4, 00, 0),
    "location": "In the info header",
    "doc_url": "https://github.com/JoseConseco/GoB/wiki",                
    "tracker_url": "https://github.com/JoseConseco/GoB/issues/new",
    "category": "Import-Export"}


classes = (
    GoB.GoB_OT_import,
    GoB.GoB_OT_export,
    GoB.GoB_OT_export_button,
    GoB.GoB_OT_GoZ_Installer,
    GoB.GOB_OT_Popup,
    preferences.GoB_Preferences,
    addon_updater.AU_OT_SearchUpdates,
    )


def register():
    [bpy.utils.register_class(c) for c in classes]

    global icons
    icons = bpy.utils.previews.new()
    icons_dir = os.path.join(os.path.dirname(__file__), "icons")
    icons.load("GOZ_SEND", os.path.join(icons_dir, "goz_send.png"), 'IMAGE')
    icons.load("GOZ_SYNC_ENABLED", os.path.join(icons_dir, "goz_sync_enabled.png"), 'IMAGE')
    icons.load("GOZ_SYNC_DISABLED", os.path.join(icons_dir, "goz_sync_disabled.png"), 'IMAGE')
    GoB.preview_collections["main"] = icons 
    bpy.types.TOPBAR_HT_upper_bar.prepend(GoB.draw_goz_buttons)
    bpy.app.translations.register(__package__, GetTranslationDict())



def unregister():

    for preferences.custom_icons in GoB.preview_collections.values():
        bpy.utils.previews.remove(icons)
    GoB.preview_collections.clear()

    bpy.types.TOPBAR_HT_upper_bar.remove(GoB.draw_goz_buttons)

    [bpy.utils.unregister_class(c) for c in classes]

    if bpy.app.timers.is_registered(GoB.run_import_periodically):
        bpy.app.timers.unregister(GoB.run_import_periodically)
    bpy.app.translations.unregister(__package__)
